Attribute VB_Name = "modTaskDialogIndirect"
' vb@rchiv - Das groe Visual-Basic Archiv
' Tools & Components - Entwicklerkomponenten fr VB-32 Bit
'
' Copyright 2000-2010 Dieter Otter
' Tipp-Autor: Julis Lszl
'
' Der Programmcode darf fr eigene Zwecke verwendet werden.
' Es ist nicht erlaubt Inhalte des Projektes ohne unserer
' Zustimmung zum Download anzubieten.
'
' Die Beispielskripte sind Computerprogramme, die gem
' des 2 Abs. 1 Nr. 69 aff. UrhG den urheberrechtlichen
' Schutz geniessen und drfen nicht fr eigene ausgegeben
' werden.
'
' Dieter Otter
' Software-Entwicklung & Vertrieb
' info@vbarchiv.de
' http://www.vbarchiv.de
' http://www.visualbasic-archiv.de
'
' info@tools4vb.de
' http://www.tools4vb.de
'======================================================

'Siehe mehr ber TaskDialogIndirect:
'http://msdn.microsoft.com/en-us/library/bb760544(VS.85).aspx

'======================================================

'API fr den Aufruf des neuesten CommonControls auf dem Rechner:
Public Declare Function InitCommonControls Lib "comctl32.dll" () As Long

'APIs fr Abfangen Mausposition und Mausklick:
Public Declare Function GetActiveWindow Lib "User32" () As Long
Public Declare Function ShellExecute Lib "shell32.dll" _
  Alias "ShellExecuteA" ( _
  ByVal hWnd As Long, _
  ByVal lpOperation As String, _
  ByVal lpFile As String, _
  ByVal lpParameters As String, _
  ByVal lpDirectory As String, _
  ByVal nShowCmd As Long) As Long

Declare Function SetTimer Lib "User32" _
            (ByVal hWnd As Long, _
            ByVal nIDEvent As Long, _
            ByVal uElapse As Long, _
            ByVal lpTimerFunc As Long) As Long

Declare Function KillTimer Lib "User32" _
            (ByVal hWnd As Long, _
            ByVal nIDEvent As Long) As Long
Public lngTimerID As Long

Private Declare Function GetClassName& Lib "User32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long)
Private Declare Function GetAsyncKeyState Lib "User32" (ByVal vKey As Long) As Integer
Private Const VK_LBUTTON = &H1
Private Const VK_RBUTTON = &H2
Private Const VK_MBUTTON = &H4

Private Declare Function GetCursorPos Lib "User32" _
  (lpPoint As POINTAPI) As Long
Private Declare Function WindowFromPoint Lib "User32" _
  (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function SendMessage Lib "User32" Alias _
        "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As _
        Long, ByVal wParam As Long, lParam As Any) As Long
Private Const WM_GETTEXT = &HD
Private Const WM_SETTEXT As Long = &HC

Private Type POINTAPI
  x As Long
  y As Long
End Type

Const LB_ITEMFROMPOINT = &H1A9

'--------------------------------------------------------

'APIs fr den Task-Dialog:

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Const WM_USER = &H400&

Public Enum TASKDIALOG_FLAGS
    TDF_ENABLE_HYPERLINKS = &H1&
    TDF_USE_HICON_MAIN = &H2&
    TDF_USE_HICON_FOOTER = &H4&
    TDF_ALLOW_DIALOG_CANCELLATION = &H8&
    TDF_USE_COMMAND_LINKS = &H10&
    TDF_USE_COMMAND_LINKS_NO_ICON = &H20&
    TDF_EXPAND_FOOTER_AREA = &H40&
    TDF_EXPANDED_BY_DEFAULT = &H80&
    TDF_VERIFICATION_FLAG_CHECKED = &H100&
    TDF_SHOW_PROGRESS_BAR = &H200&
    TDF_SHOW_MARQUEE_PROGRESS_BAR = &H400&
    TDF_CALLBACK_TIMER = &H800&
    TDF_POSITION_RELATIVE_TO_WINDOW = &H1000&
    TDF_RTL_LAYOUT = &H2000&
    TDF_NO_DEFAULT_RADIO_BUTTON = &H4000&
    TDF_CAN_BE_MINIMIZED = &H8000&
End Enum
'typedef DWORD TASKDIALOG_FLAGS;                         // Note: _TASKDIALOG_FLAGS is an int

Public Enum TASKDIALOG_MESSAGES
    TDM_NAVIGATE_PAGE = WM_USER + 101&
    TDM_CLICK_BUTTON = WM_USER + 102&                  '// wParam = Button ID
    TDM_SET_MARQUEE_PROGRESS_BAR = WM_USER + 103&      '// wParam = 0 (nonMarque) wParam != 0 (Marquee)
    TDM_SET_PROGRESS_BAR_STATE = WM_USER + 104&        '// wParam = new progress state
    TDM_SET_PROGRESS_BAR_RANGE = WM_USER + 105&        '// lParam = MAKELPARAM(nMinRange& nMaxRange)
    TDM_SET_PROGRESS_BAR_POS = WM_USER + 106&          '// wParam = new position
    TDM_SET_PROGRESS_BAR_MARQUEE = WM_USER + 107&      '// wParam = 0 (stop marquee), wParam != 0 (start marquee), lparam = speed (milliseconds between repaints)
    TDM_SET_ELEMENT_TEXT = WM_USER + 108&              '// wParam = element (TASKDIALOG_ELEMENTS), lParam = new element text (LPCWSTR)
    TDM_CLICK_RADIO_BUTTON = WM_USER + 110&            '// wParam = Radio Button ID
    TDM_ENABLE_BUTTON = WM_USER + 111&                 '// lParam = 0 (disable), lParam != 0 (enable), wParam = Button ID
    TDM_ENABLE_RADIO_BUTTON = WM_USER + 112&           '// lParam = 0 (disable), lParam != 0 (enable), wParam = Radio Button ID
    TDM_CLICK_VERIFICATION = WM_USER + 113&            '// wParam = 0 (unchecked), 1 (checked), lParam = 1 (set key focus)
    TDM_UPDATE_ELEMENT_TEXT = WM_USER + 114&           '// wParam = element (TASKDIALOG_ELEMENTS), lParam = new element text (LPCWSTR)
    TDM_SET_BUTTON_ELEVATION_REQUIRED_STATE = WM_USER + 115& '// wParam = Button ID, lParam = 0 (elevation not required)& lParam != 0 (elevation required)
    TDM_UPDATE_ICON = WM_USER + 116&                   '// wParam = icon element (TASKDIALOG_ICON_ELEMENTS), lParam = new icon (hIcon if TDF_USE_HICON_* was set, PCWSTR otherwise)
End Enum 'TASKDIALOG_MESSAGES;

Public Enum TASKDIALOG_NOTIFICATIONS
    TDN_CREATED = 0
    TDN_NAVIGATED = 1
    TDN_BUTTON_CLICKED = 2           '// wParam = Button ID
    TDN_HYPERLINK_CLICKED = 3        '// lParam = (LPCWSTR)pszHREF
    TDN_TIMER = 4                    '// wParam = Milliseconds since dialog created or timer reset
    TDN_DESTROYED = 5
    TDN_RADIO_BUTTON_CLICKED = 6     '// wParam = Radio Button ID
    TDN_DIALOG_CONSTRUCTED = 7
    TDN_VERIFICATION_CLICKED = 8     '// wParam = 1 if checkbox checked, 0 if not, lParam is unused and always 0
    TDN_HELP = 9
    TDN_EXPANDO_BUTTON_CLICKED = 10  '// wParam = 0 (dialog is now collapsed), wParam != 0 (dialog is now expanded)
End Enum 'TASKDIALOG_NOTIFICATIONS;

Public Type TASKDIALOG_BUTTON
    nButtonID As Long 'int
    pszButtonText As Long 'PCWSTR
End Type 'TASKDIALOG_BUTTON;

Public Enum TASKDIALOG_ELEMENTS
    TDE_CONTENT = 0
    TDE_EXPANDED_INFORMATION = 1
    TDE_FOOTER = 2
    TDE_MAIN_INSTRUCTION = 3
End Enum 'TASKDIALOG_ELEMENTS;

Public Enum TASKDIALOG_ICON_ELEMENTS
    TDIE_ICON_MAIN = 0
    TDIE_ICON_FOOTER = 1
End Enum 'TASKDIALOG_ICON_ELEMENTS;

Public Const TD_WARNING_ICON As Integer = -1       'MAKEINTRESOURCEW(-1)
Public Const TD_ERROR_ICON As Integer = -2         'MAKEINTRESOURCEW(-2)
Public Const TD_INFORMATION_ICON As Integer = -3   'MAKEINTRESOURCEW(-3)
Public Const TD_SHIELD_ICON As Integer = -4        'MAKEINTRESOURCEW(-4)
Public Const TD_SECURITY_ICON_BLUE As Integer = -5
Public Const TD_SECURITY_ICON_WARNING As Integer = -6
Public Const TD_SECURITY_ICON_ERROR As Integer = -7
Public Const TD_SECURITY_ICON_OK As Integer = -8
Public Const TD_SECURITY_ICON_GREY As Integer = -9
Public Const TD_QUESTION_ICON As Integer = 32514

Public Enum TASKDIALOG_COMMON_BUTTON_FLAGS
    TDCBF_OK_BUTTON = &H1&               '// selected control return value IDOK
    TDCBF_YES_BUTTON = &H2&              '// selected control return value IDYES
    TDCBF_NO_BUTTON = &H4&               '// selected control return value IDNO
    TDCBF_CANCEL_BUTTON = &H8&           '// selected control return value IDCANCEL
    TDCBF_RETRY_BUTTON = &H10&           '// selected control return value IDRETRY
    TDCBF_CLOSE_BUTTON = &H20&           '// selected control return value IDCLOSE
End Enum
'typedef DWORD TASKDIALOG_COMMON_BUTTON_FLAGS;           // Note: _TASKDIALOG_COMMON_BUTTON_FLAGS is an int

Public Type TASKDIALOGCONFIG
    cbSize As Long 'UINT
    hwndParent As Long 'HWND
    hInstance As Long 'HINSTANCE                        // used for MAKEINTRESOURCE() strings
    dwFlags As TASKDIALOG_FLAGS 'TASKDIALOG_FLAGS       // TASKDIALOG_FLAGS (TDF_XXX) flags
    dwCommonButtons As TASKDIALOG_COMMON_BUTTON_FLAGS ' // TASKDIALOG_COMMON_BUTTON (TDCBF_XXX) flags
    pszWindowTitle As Long 'PCWSTR                      // string or MAKEINTRESOURCE()
'    Union
'    {
        hMainIcon As Long
'        HICON   hMainIcon;
'        PCWSTR  pszMainIcon;
'    };
    pszMainInstruction As Long 'PCWSTR
    pszContent As Long 'PCWSTR
    cButtons As Long 'UINT
    pButtons As Long 'const TASKDIALOG_BUTTON  *pButtons;
    nDefaultButton As Long 'int
    cRadioButtons As Long 'UINT
    pRadioButtons As Long 'const TASKDIALOG_BUTTON  *pRadioButtons;
    nDefaultRadioButton As Long 'int
    pszVerificationText As Long 'PCWSTR
    pszExpandedInformation As Long 'PCWSTR
    pszExpandedControlText As Long 'PCWSTR
    pszCollapsedControlText As Long 'PCWSTR
    'Union
    '{
        hFooterIcon As Long
    '    HICON   hFooterIcon;
    '    PCWSTR  pszFooterIcon;
    '};
    pszFooter As Long 'PCWSTR
    pfCallback As Long 'PFTASKDIALOGCALLBACK
    lpCallbackData As Long 'LONG_PTR
    cxWidth As Long 'UINT             // width of the Task Dialog's client area in DLU's. If 0, Task Dialog will calculate the ideal width.
End Type

'WINCOMMCTRLAPI HRESULT WINAPI TaskDialogIndirect(const TASKDIALOGCONFIG *pTaskConfig, __out_opt int *pnButton, __out_opt int *pnRadioButton, __out_opt BOOL *pfVerificationFlagChecked);
Public Declare Function TaskDialogIndirect Lib "comctl32.dll" ( _
    pTaskConfig As TASKDIALOGCONFIG, pnButton As Long, _
    pnRadioButton As Long, pfVerificationFlagChecked As Long) As Long
'WINCOMMCTRLAPI HRESULT WINAPI TaskDialog(__in_opt HWND hwndParent, __in_opt HINSTANCE hInstance, __in_opt PCWSTR pszWindowTitle, __in_opt PCWSTR pszMainInstruction, __in_opt PCWSTR pszContent, TASKDIALOG_COMMON_BUTTON_FLAGS dwCommonButtons, __in_opt PCWSTR pszIcon, __out_opt int *pnButton);
'Public Declare Function TaskDialog Lib "Comctl32.dll" ( _
    ByVal hwndParent As Long, ByVal hInstance As Long, ByVal pszWindowTitle As Long, _
    ByVal pszMainInstruction As Long, ByVal pszContent As Long, _
    ByVal dwCommonButtons As TASKDIALOG_COMMON_BUTTON_FLAGS, _
    ByVal pszIcon As Long, pnButton As Long) As Long

Private Const IDOK = 1
Private Const IDCANCEL = 2
Private Const IDABORT = 3
Private Const IDRETRY = 4
Private Const IDIGNORE = 5
Private Const IDYES = 6
Private Const IDNO = 7
Public Sub TaskDialogTimerProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long)

 Dim oPoint As POINTAPI
 Dim hWnd1 As Long
 Dim lLength As Long
 Dim sWindowText As String * 255
 Dim A%, B%
 
 On Local Error GoTo TaskDialogTimerProcFehler
 
 'Aktuelle Mausposition:
 If GetCursorPos(oPoint) <> 0 Then
  'hWnd-Eigenschaft vom Steuerelement unter dem Mauszeiger:
  hWnd1 = WindowFromPoint(oPoint.x, oPoint.y)
  'Text unter dem Mauszeiger:
  lLength = SendMessage(hWnd1, WM_GETTEXT, Len(sWindowText) + 1, ByVal sWindowText)
  sWindowText = Left(sWindowText, lLength)
  'Wenn linke Maustaste gedrckt:
  If Get_ButtonStatus = 1 Then
   'Ob Text unter dem Mauszeiger einen URL darstellt:
   If InStr(1, LCase(sWindowText), "href") > 0 Then
    A% = InStr(1, LCase(sWindowText), "href") + 6
    B% = InStr(A%, LCase(sWindowText), ">")
    'URL ffnen im Internet Explorer:
    Shell "Explorer " + Mid(sWindowText, A%, B% - A% - 1), vbMaximizedFocus
   End If
  Else
   If InStr(1, LCase(sWindowText), "href") > 0 Then
    'Wenn keine Maustaste gedrckt, ToolTip fr den URL (z.B. http://www.vbarchiv.net/xtra/details.php?id=9052), oder sonstiges:
    '...
    '...
   End If
  End If
 End If
 Exit Sub
 
TaskDialogTimerProcFehler:
 MsgBox Err.Description, vbOKOnly + vbInformation, Err

End Sub




Public Function ShowTaskDlgIndirect(lhwnd As Long, sWindowTitle As String, sMainInstruction As String, sContent As String, sVerify As String, sExpanded As String, sCollapsedControlText As String, sExpandedControlText As String, Schaltflaeche1 As String, Schaltflaeche2 As String, Schaltflaeche3 As String, Voreinstellung As Integer, FussZeile As String, URLFussZeile As String, Icon As Integer) As Long

 On Local Error GoTo ShowTaskDlgIndirectFehler

 Dim tdlg As TASKDIALOGCONFIG
 Dim ClickedButton As Long
 Dim SelRadio As Long
 Dim fVerify As Long
 Dim lResult As Long
 Dim AnzahlSchaltflaechen As Integer
 Dim sWindowTitle1 As String
 
 If Trim(sExpanded) = "" Then
  sExpandedControlText = ""
  sCollapsedControlText = ""
 End If
 
 AnzahlSchaltflaechen = 1
 If Trim(Schaltflaeche2) <> "" Then
  AnzahlSchaltflaechen = 2
 End If
 If Trim(Schaltflaeche3) <> "" Then
  AnzahlSchaltflaechen = 3
 End If

 ReDim tbButtons(0 To AnzahlSchaltflaechen - 1) As TASKDIALOG_BUTTON
 tbButtons(0).nButtonID = IDYES
 tbButtons(0).pszButtonText = StrPtr(Schaltflaeche1)
 If AnzahlSchaltflaechen > 1 Then
  tbButtons(1).nButtonID = IDNO
  tbButtons(1).pszButtonText = StrPtr(Schaltflaeche2)
 End If
 If AnzahlSchaltflaechen = 3 Then
  tbButtons(2).nButtonID = IDABORT
  tbButtons(2).pszButtonText = StrPtr(Schaltflaeche3)
 End If

 tdlg.cbSize = Len(tdlg)
 tdlg.hwndParent = lhwnd
 tdlg.hInstance = 0
 If frmMain.chkCommandLinks.Value = 0 Then
  tdlg.dwFlags = TDF_ENABLE_HYPERLINKS
 Else
  tdlg.dwFlags = TDF_USE_COMMAND_LINKS Or TDF_ENABLE_HYPERLINKS
 End If
 If frmMain.chkCloseButton.Value = 0 Then
  tdlg.dwCommonButtons = 0
 Else
  tdlg.dwCommonButtons = TDCBF_CLOSE_BUTTON
 End If
 tdlg.pszWindowTitle = StrPtr(sWindowTitle)
 If Icon = 0 Then
  tdlg.hMainIcon = 0
 Else
  'Aus der Vista Ressourcen-Datei sind noch viele Icons auszulagern.
  tdlg.hMainIcon = MAKEINTRESOURCE(Icon)
 End If
 tdlg.pszMainInstruction = StrPtr(sMainInstruction)
 tdlg.pszContent = StrPtr(sContent)
 tdlg.cButtons = AnzahlSchaltflaechen
 tdlg.pButtons = VarPtr(tbButtons(0).nButtonID)
 'Radio-Button, wenn notwendig:
 'tdlg.cRadioButtons = AnzahlSchaltflaechen
 'tdlg.pRadioButtons = VarPtr(tbButtons(0).nButtonID)
 Select Case Voreinstellung
  Case 1: tdlg.nDefaultButton = IDYES
  Case 2: tdlg.nDefaultButton = IDNO
  Case 3: tdlg.nDefaultButton = IDABORT
 End Select
 tdlg.pszVerificationText = StrPtr(sVerify)
 tdlg.pszExpandedInformation = StrPtr(sExpanded)
 tdlg.pszExpandedControlText = StrPtr(sExpandedControlText)
 tdlg.pszCollapsedControlText = StrPtr(sCollapsedControlText)
 If FussZeile <> "" Then
  tdlg.hFooterIcon = MAKEINTRESOURCE(TD_INFORMATION_ICON)
  'ACHTUNG!
  'Wenn bsartige Seite gelinkt, knnen Sicherheitsprobleme entstehen!
  tdlg.pszFooter = StrPtr("<A HREF=""" + URLFussZeile + """>" + FussZeile + "</A>")
  'Smtliche Bereiche des Dialogs (Content, Expanded, Footer) kann URL enthalten.
  'Syntax: "<A HREF="http://irgendwas.com">Hyperlink Text</A>"
 End If
 tdlg.pfCallback = 0

 'Timer Prozedur aufrufen, um Mausklick auf URL abzufangen:
 'GetActiveWindow() liefert die hWnd-Eigenschaft der gerade aktiven Form, wo die Dialog gebunden wird.
 lngTimerID = SetTimer(GetActiveWindow(), 0, 200, AddressOf TaskDialogTimerProc)
 lResult = TaskDialogIndirect(tdlg, ClickedButton, SelRadio, fVerify)
 'Timer Prozedur vernichten, sonst knnen unerwartete Probleme auftreten:
 lngTimerID = KillTimer(0, lngTimerID)
 
 ShowTaskDlgIndirect = ClickedButton
 Exit Function

ShowTaskDlgIndirectFehler:
 lngTimerID = KillTimer(0, lngTimerID)
 ShowTaskDlgIndirect = -1
 MsgBox Err.Description, vbOKOnly + vbInformation, Err

End Function


Public Function MAKEINTRESOURCE(ByVal iVal As Integer) As Long

 Dim l As Long
 l = 0
 CopyMemory l, iVal, 2
 MAKEINTRESOURCE = l

End Function
Public Sub Main()

 'ACHTUNG!
 'Wenn "InitCommonControls" nicht aufgerufen wird, bekommen wir die gewhnliche Fehlermeldung:
 '"Can't find DLL entry point TaskDialogIndirect in Comctl32.dll"
 'Diese Funktion immer in die Sub Main platzieren!
 'Die Anwendung mu XP-Theme verwenden (z.B. durch TaskDialogIndirect.exe.manifest), sonst funktioniert Vista-TaskDialog nicht!
 InitCommonControls
 
 frmMain.Show 1
 
End Sub
Public Function Get_ButtonStatus() As MouseButtonConstants
    
'Welche Maustaste geklickt:
 If GetAsyncKeyState(VK_LBUTTON) Then
   Get_ButtonStatus = vbLeftButton
  ElseIf GetAsyncKeyState(VK_RBUTTON) Then
   Get_ButtonStatus = vbRightButton
  ElseIf GetAsyncKeyState(VK_MBUTTON) Then _
   Get_ButtonStatus = vbMiddleButton
 End If
    
End Function

